package com.its.op.service.its.rse;

import com.its.op.dao.repository.its.rse.TbRseSectRltnLinkRepository;
import com.its.op.dto.its.rse.TbRseSectRltnLinkDto;
import com.its.op.entity.its.rse.TbRseSectRltnLink;
import com.its.op.entity.its.rse.TbRseSectRltnLinkKey;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbRseSectRltnLinkService {

    private final TbRseSectRltnLinkRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbRseSectRltnLink requireOne(TbRseSectRltnLinkKey id) throws NoSuchElementException {
        Optional<TbRseSectRltnLink> info = this.repo.findById(id);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + id);
        }
//        return this.repo.findById(id)
//                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbRseSectRltnLinkDto> findAll() {
        List<TbRseSectRltnLinkDto> result = new ArrayList<>();
        List<TbRseSectRltnLink> data = this.repo.findAll();
        for (TbRseSectRltnLink entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbRseSectRltnLinkDto findById(TbRseSectRltnLinkKey id) {
        TbRseSectRltnLink entity = requireOne(id);
        return entity.toDto();
    }

    // 데이터 변경
    @Transactional
    public TbRseSectRltnLinkDto updateById(TbRseSectRltnLinkKey id, TbRseSectRltnLinkDto.TbRseSectRltnLinkUpdReq req) {
        TbRseSectRltnLink entity = requireOne(id);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbRseSectRltnLinkDto> mergeInfoList(List<TbRseSectRltnLinkDto.TbRseSectRltnLinkUpdReq> reqList) {
        List<TbRseSectRltnLinkDto> result = new ArrayList<>();
        for (TbRseSectRltnLinkDto.TbRseSectRltnLinkUpdReq req : reqList) {
            TbRseSectRltnLink obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbRseSectRltnLinkDto mergeInfo(TbRseSectRltnLinkDto.TbRseSectRltnLinkUpdReq req) {
        TbRseSectRltnLink obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbRseSectRltnLinkDto deleteById(TbRseSectRltnLinkKey id) {
        TbRseSectRltnLink entity = requireOne(id);
        this.repo.deleteById(id);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbRseSectRltnLinkDto> deleteByIds(List<TbRseSectRltnLinkKey> ids) {
        List<TbRseSectRltnLinkDto> result = new ArrayList<>();
        for (TbRseSectRltnLinkKey id : ids) {
            Optional<TbRseSectRltnLink> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

}
